#include "StdAfx.h"
#include ".\Envelop.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//		bool		_sub	̃IuWFNǵATu[`H
//	Ԓl
//					
//==============================================================
Envelop::Envelop(MMLfile* MML, unsigned int _id, const char _strName[]):
	MusicItem(_strName),
	m_id(_id)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_mml {
	Env_Num,
	Env_Sweep,
	Env_Hold,
	Env_Loop,
	Env_Release,
	Env_Commma
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"$",	Env_Num		},
		{	"%",	Env_Num		},
		{	"-",	Env_Num		},
		{	"0",	Env_Num		},
		{	"1",	Env_Num		},
		{	"2",	Env_Num		},
		{	"3",	Env_Num		},
		{	"4",	Env_Num		},
		{	"5",	Env_Num		},
		{	"6",	Env_Num		},
		{	"7",	Env_Num		},
		{	"8",	Env_Num		},
		{	"9",	Env_Num		},
		{	"{",	Env_Sweep	},
		{	"d",	Env_Hold	},
		{	"D",	Env_Hold	},
		{	"|",	Env_Loop	},
		{	"l",	Env_Loop	},
		{	"L",	Env_Loop	},
		{	"r",	Env_Release	},
		{	"R",	Env_Release	},
		{	",",	Env_Commma	}
};

	unsigned	char	cData;
				int		i;
				int		Loop_Normal		= -1;
				int		Loop_Release	= -1;
				bool	Release			= false;
	unsigned	int		ptEnvelop		= 1;

	//------------------------------
	//NX̏ݒ


	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err("ubN̊Jn{܂B");
		}
	}

	code.resize(0);
	code.append((char)1, (char)0);

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err("ubN̏I[`}'܂B");
		}

		//P߂
		MML->Back();


		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(Env_Num):
				MML->Back();
				i = MML->GetInt();
				if( (i<-64) || (i>63)){
					MML->Err("Gx[v́A-64`63͈̔͂Ŏw肵ĉB");
				}
				code.append((char)1, (char)i & 0x7F);
				ptEnvelop++;
				break;

			case(Env_Sweep):
				break;

			case(Env_Hold):
				i = MML->GetInt();
				if( (i<0) || (i>255)){
					MML->Err("ێԂ́A0`255͈̔͂Ŏw肵ĉB");
				}
				while(i>15){
					code.append((char)1, (char)0x8F);
					i -= 16;		//15΁A16t[ێ
				ptEnvelop++;
				}
				code.append((char)1, (char)((i & 0x0F) | 0x80));
				ptEnvelop++;
				break;

			case(Env_Loop):
				if(ptEnvelop > 0x3F){
					MML->Err("[vʒuwł͈͂𒴂܂B");
				}
				if(Release == false){
					Loop_Normal		= ptEnvelop;
				} else {
					Loop_Release	= ptEnvelop;
				}
				break;

			case(Env_Release):
				if(Loop_Normal == -1){
					MML->Warning("[v|Cg܂BŌ̒l[v܂B");
					code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
				} else {
					if(ptEnvelop == Loop_Normal){
						MML->Err("LR}h̒RR}huƂ͂ł܂B");
					}
					code.append((char)1, (char)(Loop_Normal | 0xC0));
				}
				ptEnvelop++;
				code[0] = ptEnvelop;
				Release = true;
				break;

			case(Env_Commma):
				break;

			//unknown command
			default:
				MML->Err("unknown command");
				break;
		}
	}

	if(Release == true){
		if(Loop_Release == -1){
			MML->Warning("[X̃[v|Cg܂BŌ̒l[v܂B");
			code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
		} else {
			if(ptEnvelop == Loop_Release){
				MML->Err("LR}hŃp^[`I邱Ƃ͂ł܂B");
			}
			code.append((char)1, (char)(Loop_Release | 0xC0));
		}
	} else {
		if(Loop_Normal == -1){
			MML->Warning("[v|Cg܂BŌ̒l[v܂B");
			code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
		} else {
			if(ptEnvelop == Loop_Normal){
				MML->Err("LR}hŃp^[`I邱Ƃ͂ł܂B");
			}
			code.append((char)1, (char)(Loop_Normal | 0xC0));
		}
	}

	iSize = code.size();
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
Envelop::~Envelop(void)
{
}
//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	Envelop::getAsm(MusicFile* MUS)
{
	*MUS << MUS->Header.Label.c_str() << "Envelope" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
