#include "StdAfx.h"
#include ".\trackset.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//		bool		_sub	̃IuWFNǵATu[`H
//	Ԓl
//					
//==============================================================
TrackSet::TrackSet(MMLfile* MML, unsigned int _id, bool _sub, const char _strName[]):
	MusicItem(_strName),
	m_id(_id)
{
	//----------------------
	//Localϐ

//	萔`
enum	Command_ID_mml {
	mml_Track,
	mml_KeySignature,
	mml_Macro,
	mml_Subroutine,

	mml_Loop,
	mml_Repeat_A_Start,
	mml_Repeat_A_Branch,
	mml_Repeat_A_End,
	mml_Repeat_B_Start,
	mml_Repeat_B_Branch,
	mml_Repeat_B_End,

	mml_Tempo,
	mml_Tempo_Relative,

	mml_La,
	mml_Si,
	mml_Do,
	mml_Re,
	mml_Mi,
	mml_Fa,
	mml_Sol,
	mml_Rest,
	mml_Tai,

	mml_Length,
	mml_Gate_q,
	mml_Gate_u,

	mml_Envelop_Voice,
	mml_Envelop_Volume,
	mml_Envelop_Frequency,
	mml_Envelop_Note,

	mml_Envelop_Off_Voice,
	mml_Envelop_Off_Volume,
	mml_Envelop_Off_Frequency,
	mml_Envelop_Off_Note,

	mml_Release_mdoe,
	mml_Release_Voice,
	mml_Release_Volume,

	mml_Voice,

	mml_Octave,
	mml_Octave_Up,
	mml_Octave_Down,
	mml_Octave_Up1,
	mml_Octave_Down1,
	mml_Detune_Cent,
	mml_Detune_Register,
	mml_Transpose,
	mml_Transpose_Relative,
	mml_Protament,
	mml_Sweep,

	mml_Volume,
	mml_Volume_Up,
	mml_Volume_Down,

	mml_Memory_Write,

	mml_Bar
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"TR",	mml_Track				},
		{	"K",	mml_KeySignature,		},
		{	"S",	mml_Subroutine			},
		{	"$",	mml_Macro,				},

		{	"L",	mml_Loop				},
		{	"|:",	mml_Repeat_B_Start		},
		{	"\\",	mml_Repeat_B_Branch		},
		{	":|",	mml_Repeat_B_End		},
		{	"[",	mml_Repeat_A_Start		},
		{	":",	mml_Repeat_A_Branch		},
		{	"]",	mml_Repeat_A_End		},

		{	"t_",	mml_Tempo_Relative,		},
		{	"t",	mml_Tempo,				},

		{	"a",	mml_La					},
		{	"b",	mml_Si					},
		{	"c",	mml_Do					},
		{	"d",	mml_Re					},
		{	"e",	mml_Mi					},
		{	"f",	mml_Fa					},
		{	"g",	mml_Sol					},
		{	"r",	mml_Rest				},
		{	"^",	mml_Tai					},

		{	"l",	mml_Length				},
		{	"q",	mml_Gate_q				},
		{	"u",	mml_Gate_u				},

		{	"E@*",	mml_Envelop_Off_Voice		},
		{	"Ev*",	mml_Envelop_Off_Volume		},
		{	"Em*",	mml_Envelop_Off_Frequency	},
		{	"En*",	mml_Envelop_Off_Note		},

		{	"E@",	mml_Envelop_Voice		},
		{	"Ev",	mml_Envelop_Volume		},
		{	"Em",	mml_Envelop_Frequency	},
		{	"En",	mml_Envelop_Note		},

		{	"Rm",	mml_Release_mdoe		},
		{	"R@",	mml_Release_Voice		},
		{	"Rv",	mml_Release_Volume		},

		{	"@",	mml_Voice				},		//

		{	"o",	mml_Octave				},
		{	">",	mml_Octave_Up			},
		{	"<",	mml_Octave_Down			},
		{	"`",	mml_Octave_Up1			},
		{	"\"",	mml_Octave_Down1		},
		{	"D%",	mml_Detune_Register		},
		{	"D",	mml_Detune_Cent			},
		{	"__",	mml_Transpose_Relative	},
		{	"_",	mml_Transpose			},
		{	"P",	mml_Protament			},		//
		{	"s",	mml_Sweep				},

		{	"v",	mml_Volume				},
		{	")",	mml_Volume_Up			},
		{	"(",	mml_Volume_Down			},

		{	"y",	mml_Memory_Write		},

		{	"|",	mml_Bar					}
};

	unsigned	char	cData;
				int		i;

	//------------------------------
	//NX̏ݒ
	fSub		= _sub;		//Tu[`̃tO
	iTrack		= 0;		//RpC̃gbNiDefault = 0j
	maxTrack	= 0;		//őgbNԍ

	//܂́APgbNi0ԁj̃IuWFNgB
	nowTrack	= makeTrack(iTrack);



	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err("ubN̊Jn{܂B");
		}
	}

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err("ubN̏I[`}'܂B");
		}

		//P߂
		MML->Back();


		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(mml_Track):
				if(fSub == true){
					MML->Warning("SububNȂł̓gbNw͂ł܂B܂B");
				}
				iTrack = MML->GetInt() - 1;
				if( (iTrack < 0) ){
					MML->Err("gbNԍŎwł͈͂𒴂Ă܂B");
				}
				nowTrack = getTrack(iTrack);
				break;

			case(mml_KeySignature):
				nowTrack->SetKeySignature(MML);
				break;

			case(mml_Macro):
				// to do 
				break;

			case(mml_Subroutine):
				nowTrack->SetSubroutine(MML);
				break;

			case(mml_Loop):
				if(fSub == true){
					MML->Warning("SububNȂł͖[v͂ł܂B܂B");
				} else {
					nowTrack->SetLoop();
				}
				break;

			case(mml_Repeat_A_Start):
				nowTrack->SetRepeat_A_Start(MML);
				break;

			case(mml_Repeat_A_Branch):
				nowTrack->SetRepeat_A_Branch(MML);
				break;

			case(mml_Repeat_A_End):
				nowTrack->SetRepeat_A_End(MML);
				break;

			case(mml_Repeat_B_Start):
				nowTrack->SetRepeat_B_Start(MML);
				break;

			case(mml_Repeat_B_Branch):
				nowTrack->SetRepeat_B_Branch(MML);
				break;

			case(mml_Repeat_B_End):
				nowTrack->SetRepeat_B_End(MML);
				break;

			case(mml_Tempo):
				nowTrack->SetEvent(new mml_general(nsd_Tempo, MML, "Tempo"));
				break;

			case(mml_Tempo_Relative):
				nowTrack->SetEvent(new mml_general(nsd_Relative_Tempo, MML, "Relative Tempo"));
				break;

			case(mml_La):
				nowTrack->SetNote(MML, 5);
				break;

			case(mml_Si):
				nowTrack->SetNote(MML, 6);
				break;

			case(mml_Do):
				nowTrack->SetNote(MML, 0);
				break;

			case(mml_Re):
				nowTrack->SetNote(MML, 1);
				break;

			case(mml_Mi):
				nowTrack->SetNote(MML, 2);
				break;

			case(mml_Fa):
				nowTrack->SetNote(MML, 3);
				break;

			case(mml_Sol):
				nowTrack->SetNote(MML, 4);
				break;

			case(mml_Rest):
				nowTrack->SetRest(MML);
				break;

			case(mml_Tai):
				nowTrack->SetTai(MML);
				break;

			case(mml_Length):
				nowTrack->SetLength(MML);
				break;

			case(mml_Gate_q):
				nowTrack->SetGatetime(MML);
				break;

			case(mml_Gate_u):
				nowTrack->SetGatetime_u(MML);
				break;

			case(mml_Envelop_Voice):
				nowTrack->SetEnvelop(nsd_Envelop_Voice, MML);
				break;

			case(mml_Envelop_Volume):
				nowTrack->SetEnvelop(nsd_Envelop_Volume, MML);
				break;

			case(mml_Envelop_Frequency):
				nowTrack->SetEnvelop(nsd_Envelop_Frequency, MML);
				break;

			case(mml_Envelop_Note):
				nowTrack->SetEnvelop(nsd_Envelop_Note, MML);
				break;

			case(mml_Envelop_Off_Voice):
				MML->Err("FGx[v́A@R}hŖɂł܂B");
				break;

			case(mml_Envelop_Off_Volume):
				nowTrack->SetEvent(new mml_Address(nsd_Envelop_Volume));
				break;

			case(mml_Envelop_Off_Frequency):
				nowTrack->SetEvent(new mml_Address(nsd_Envelop_Frequency));
				break;

			case(mml_Envelop_Off_Note):
				nowTrack->SetEvent(new mml_Address(nsd_Envelop_Note));
				break;

			case(mml_Release_mdoe):
				nowTrack->SetReleaseMode(MML);
				break;

			case(mml_Release_Voice):
				nowTrack->SetReleaseVoice(MML);
				break;

			case(mml_Release_Volume):
				nowTrack->SetReleaseVolume(MML);
				break;

			case(mml_Voice):
				nowTrack->SetEvent(new mml_general(nsd_Voice, MML, "Voice"));
				break;

			case(mml_Octave):
				nowTrack->SetOctave(MML);
				break;

			case(mml_Octave_Up):
				if(MML->octave_reverse == true){
					nowTrack->SetEvent(new mml_general(nsd_Octave_Down, "Octave Down"));
				} else {
					nowTrack->SetEvent(new mml_general(nsd_Octave_Up, "Octave Up"));
				}
				break;

			case(mml_Octave_Down):
				if(MML->octave_reverse == true){
					nowTrack->SetEvent(new mml_general(nsd_Octave_Up, "Octave Up"));
				} else {
					nowTrack->SetEvent(new mml_general(nsd_Octave_Down, "Octave Down"));
				}
				break;

			case(mml_Octave_Up1):
				nowTrack->SetEvent(new mml_general(nsd_Octave_Up_1, "One time octave up"));
				break;

			case(mml_Octave_Down1):
				nowTrack->SetEvent(new mml_general(nsd_Octave_Down_1, "One time octave down"));
				break;

			case(mml_Detune_Cent):
				nowTrack->SetEvent(new mml_general(nsd_Detune_Cent, MML, "Detune Cent"));
				break;

			case(mml_Detune_Register):
				nowTrack->SetEvent(new mml_general(nsd_Derune_Register, MML, "Derune Register"));
				break;

			case(mml_Transpose):
				nowTrack->SetEvent(new mml_general(nsd_Transpose, MML, "Transpose"));
				break;

			case(mml_Transpose_Relative):
				nowTrack->SetEvent(new mml_general(nsd_Relative_Transpose, MML, "Relative Transpose"));
				break;

			case(mml_Protament):
				nowTrack->SetProtament(MML);
				break;

			case(mml_Sweep):
				nowTrack->SetSweep(MML);
				break;

			case(mml_Volume):
				nowTrack->SetVolume(MML);
				break;

			case(mml_Volume_Up):
				nowTrack->SetEvent(new mml_general(nsd_Volume_Up, "Volume up"));
				break;

			case(mml_Volume_Down):
				nowTrack->SetEvent(new mml_general(nsd_Volume_Down, "Volume down"));
				break;

			case(mml_Memory_Write):
				nowTrack->SetPoke(MML);
				break;

			case(mml_Bar):
				break;

			//unknown command
			default:
				MML->Err("unknown command");
				break;
		}
	}

	if(fSub == true){
		//Tu[`ubN̏ꍇ
		code.resize(0);
		i = (int)ptcTrack[iTrack]->SetEnd();

	} else {
		//ȊȌꍇ
		i = 2 + ((maxTrack + 1) * 2);		//gbNwb_[̃TCYvZB
		code.resize(i);						//wb_pɃR[hTCYm

		code[0] = maxTrack + 1;				//gbN
		code[1] = 0;						//

		//egbNɏI[āAȃf[^̃AhX쐬
		iTrack = 0;
		while(iTrack <= maxTrack){
			code[iTrack *2 + 2]	= ((i   ) & 0xFF);
			code[iTrack *2 + 3]	= ((i>>8) & 0xFF);
			i += (int)ptcTrack[iTrack]->SetEnd();
			iTrack++;
		}
	}
	iSize = i;

}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
TrackSet::~TrackSet(void)
{
}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	TrackSet::Fix_Address(map<int, Sub*>* ptcSub, map<int, Envelop*>* ptcEnvelop)
{
	iTrack = 0;
	while(iTrack <= maxTrack){
		ptcTrack[iTrack]->Fix_Address(ptcSub, ptcEnvelop);
		iTrack++;
	}

}
//==============================================================
//		gbN̍쐬
//--------------------------------------------------------------
//	
//		unsigned int _track		gbNԍ
//	Ԓl
//		MusicTrack*				gbNEIuWFNg̃|C^
//==============================================================
MusicTrack*	TrackSet::makeTrack(int _track)
{
	//gbÑIuWFNg𐶐B
	MusicTrack*	newTrack	= new MusicTrack();

	//ACe͕ۑ
	ptcItem.push_back(newTrack);		//NX"MusicItem"ŊJB
	ptcTrack[_track] = newTrack;

	//|C^n
	return(newTrack);
}

//==============================================================
//		gbNEIuWFNg̃|C^擾
//--------------------------------------------------------------
//	
//		unsigned int _track		gbNԍ
//	Ԓl
//		MusicTrack*				gbNEIuWFNg̃|C^
//	Ԓl
//		w肳ꂽԍ̃gbNEIuWFNg̃|C^擾
//		ꍇ͐VɃgbNāA
//		gbNԍől𒴂ĂőlXVB
//==============================================================
MusicTrack*	TrackSet::getTrack(int _track)
{
			int	i			 = maxTrack;	// i = AŏIgbN̔ԍ
	MusicTrack*	_getTrack;

	//ŏIgbNԍwlAJԂB
	while(i < _track){
		i++;
		//gbN
		if(ptcTrack.count(i) == 0){
			_getTrack	= makeTrack(i);
		} else {
			cout << "MusicTrack* TrackSet::getTrack()֐ŃG[܂B" << endl;
			exit(-1);
		}
	}
	maxTrack = i;	//gbN̍őlLB

	//|C^擾B
	_getTrack = ptcTrack[_track];

	return(_getTrack);
}
//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	TrackSet::getAsm(MusicFile* MUS)
{
	//----------------------
	//Localϐ
	unsigned	int	i = 0;
	vector<	MusicItem*>::iterator	itItem;

	if(fSub == false){
		*MUS << "	.byte	$" << hex << setw(2) << setfill('0') << (int)(code[0] & 0xFF) << ", $" << (int)(code[1] & 0xFF) << endl;
		while(i <= maxTrack){
			if(i==0){
				*MUS << "	.word	$";
			} else {
				*MUS << " ,$";
			}
			*MUS << hex << setw(4) << setfill('0') << (int)((code[i*2+2] & 0xFF) | ((code[i*2+3] & 0xFF)<<8));
			i++;
		}
		*MUS << dec << endl;
	}

	if(!ptcItem.empty()){
		itItem = ptcItem.begin();
		while(itItem != ptcItem.end()){
			(*itItem)->getAsm(MUS);
			itItem++;
		}
	}
}
